"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This middleware injects a default Accept header.
 *
 * The list of content-types is generated from the Client's
 * 'contentTypeMap'.
 */
function default_1(client) {
    return async (request, next) => {
        if (!request.headers.has('Accept')) {
            const acceptHeader = Object.entries(client.contentTypeMap).map(([contentType, [, q]]) => contentType + ';q=' + q).join(', ');
            request.headers.set('Accept', acceptHeader);
        }
        return next(request);
    };
}
exports.default = default_1;
//# sourceMappingURL=accept-header.js.map