"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.factory = void 0;
const base_state_1 = require("./base-state");
const util_1 = require("../http/util");
/**
 * Turns a HTTP response into a BinaryState
 */
const factory = async (client, uri, response) => {
    return new base_state_1.BaseState({
        client,
        uri,
        data: await response.blob(),
        headers: response.headers,
        links: (0, util_1.parseLink)(uri, response.headers.get('Link')),
    });
};
exports.factory = factory;
//# sourceMappingURL=binary.js.map